if($Pref::Music::CheckRate $= "")
	$Pref::Music::CheckRate = 500;
if($Pref::Music::Favs::Count $= "")
	$Pref::Music::Favs::Count = 0;

new AudioDescription(AdMusic2D)
{
	is3D = 0;
	isLooping = 1;
	loopcount = -1;
	type = 8;
	volume = 1;
};
//Load the GUI
exec("./AdMusicGUI.gui");
$AdMusicDir = "Add-ons/Music/*";

function playAdMusic(%filename)
{
	if(isFile("Add-ons/Music/" @ %filename @ ".ogg"))
	{
		if(alxIsPlaying($Client::PlayingMusic))
			alxStop($Client::PlayingMusic);
		$Client::PlayingMusic = alxCreateSource(AdMusic2D, "Add-ons/Music/" @ %filename @ ".ogg");
		alxPlay($Client::PlayingMusic);
	}
}

function stopAdMusic()
{
	if(alxIsPlaying($Client::PlayingMusic))
		alxStop($Client::PlayingMusic);
	$Client::PlayingMusic = "";
}

function addMusic(%name,%duration,%size)
{
	%seconds = mFloatLength(%duration/1000,0);
	%minutes = mfloor(%seconds/60);
	%seconds = %seconds%60;
	if(%seconds < 10)
		%seconds = "0" @ %seconds;
	%newduration = %minutes @ ":" @ %seconds;
	%newsize = mFloatLength(%size/1024,0);
	adMusic_list.addRow($AdMusicGui::RowCount,%name TAB %newduration TAB %newsize TAB "KB" TAB %duration TAB %size);
	$AdMusicGui::RowCount++;
}

function adMusicSyncFavs(%count)
{
	if(%count == 1)
	{
		adMusic_syncButton.setColor("1 0.784 0.784 1");
		adMusic_syncButton.setText("Stop Sync");
		$AdMusicGui::isSyncing = 1;
	}
	if($Pref::Music::FavsCount < 1)
	{
		adMusicFinishedSync("Favorites");
		return;
	}
	%name = $Pref::Music::Favs[%count];

	if(isFile(%file = "Add-ons/Music/" @ %name @ ".ogg"))
	{
		%size = getFileLength(%file);
		%duration = alxGetWaveLen(%file);
		%seconds = mFloatLength(%duration/1000,0);
		%minutes = mfloor(%seconds/60);
		%seconds = %seconds%60;
		if(%seconds < 10)
			%seconds = "0" @ %seconds;
		%newduration = %minutes @ ":" @ %seconds;
		%newsize = mFloatLength(%size/1024,0);
		adMusic_favList.setRowByID(%count,%name TAB %newduration TAB %newsize TAB "KB" TAB %duration TAB %size);
	}
	else
		adMusic_favList.setRowByID(%count,%name TAB "N/A" TAB "N/A");
	if(%count++ <= $Pref::Music::FavsCount)
		$AdMusicGui::Sync = schedule($Pref::Music::CheckRate,0,adMusicSyncFavs,%count);
	else
		adMusicFinishedSync(Favorites);
}

function adMusicFinishedSync(%type)
{
	$AdMusicGui::Sync[%type] = 1;
	adMusic_syncButton.setColor("0.784 1 0.784 1");
	if($AdMusicGui::Sync[$AdMusicGui::ActivePane] == 1)
		adMusic_syncButton.setText("Resync");
	else
		adMusic_syncButton.setText("Sync");
	$AdMusicGui::isSyncing = 0;
}

function adMusicCheckNextFile(%file,%type,%name,%size,%duration)
{
	if(%file $= "")
	{
		adMusicFinishedSync(Music);
		return;
	}
	else if(%type !$= "ogg" || strStr(%name, "/") != "-1")
	{
		//skip
	}
	else
	{
		//normal
		addMusic(%name,%duration,%size,0);
	}
	%next = findNextFile($AdMusicDir);
	if(%next !$= "")
	{
		%filetype = getSubStr(%next,strLen(%next)-3,3);
		if(%filetype $= "ogg")
		{
			%filename = getSubStr(%next,14,strLen(%next)-18);
			%filesize = getFileLength(%next);
			%fileduration = alxGetWaveLen(%next);
		}
	}
	$AdMusicGui::Sync = schedule($Pref::Music::CheckRate,0,adMusicCheckNextFile,%next,%filetype,%filename,%filesize,%fileduration);
}

function initAdMusicCheck()
{
	if(!$AdMusicGui::isSyncing)
	{
		adMusic_syncButton.setColor("1 0.784 0.784 1");
		adMusic_syncButton.setText("Stop Sync");
		$AdMusicGui::isSyncing = 1;
		adMusic_list.clear();
		$AdMusicGui::RowCount=0;
		%next = findFirstFile($AdMusicDir);
		%filetype = getSubStr(%next,strLen(%next)-3,3);
		%filename = getSubStr(%next,14,strLen(%next)-18);
		%filesize = getFileLength(%next);
		%fileduration = alxGetWaveLen(%next);
		$AdMusicGui::Sync = schedule($Pref::Music::CheckRate,0,adMusicCheckNextFile,%next,%filetype,%filename,%filesize,%fileduration);
	}
}

function openAdMusicGUI(%val)
{
	if(%val)
	{
		if(adMusicGUI.isAwake())
			canvas.popdialog(adMusicGUI);
		else
			canvas.pushDialog(adMusicGUI);
	}
}

function adMusicButtonMusic()
{
	adMusic_scroll.setvisible(true);
	adMusic_scroll.scrollToTop();
	adMusic_list.setvisible(true);
	adMusic_favList.setvisible(false);
	adMusic_settingsPane.setvisible(false);
	adMusic_MusicButton.setColor("0.784 1 1 1");
	adMusic_FavoritesButton.setColor("0.784 0.784 1 1");
	adMusic_SettingsButton.setColor("0.784 0.784 1 1");
	$AdMusicGui::ActivePane = "Music";
	adMusic_playButton.setVisible(true);
	adMusic_stopButton.setVisible(true);
	adMusic_favsButton.setvisible(true);
	adMusic_favsButton.setText("Add to Favs");
	adMusic_nameButton.setVisible(true);
	adMusic_durButton.setVisible(true);
	adMusic_sizeButton.setVisible(true);
	adMusic_syncButton.setVisible(true);
	if($AdMusicGui::isSyncing != 1)
	{
		if($AdMusicGui::SyncMusic == 1)
			adMusic_syncButton.setText("Resync");
		else
			adMusic_syncButton.setText("Sync");
	}
}

function adMusicButtonFavorites()
{
	adMusic_scroll.setvisible(true);
	adMusic_scroll.scrollToTop();
	adMusic_list.setvisible(false);
	adMusic_favList.setvisible(true);
	adMusic_settingsPane.setvisible(false);
	adMusic_MusicButton.setColor("0.784 0.784 1 1");
	adMusic_FavoritesButton.setColor("0.784 1 1 1");
	adMusic_SettingsButton.setColor("0.784 0.784 1 1");
	$AdMusicGui::ActivePane = "Favorites";
	adMusic_playButton.setVisible(true);
	adMusic_stopButton.setVisible(true);
	adMusic_favsButton.setvisible(true);
	adMusic_favsButton.setText("Remove");
	adMusic_nameButton.setVisible(true);
	adMusic_durButton.setVisible(true);
	adMusic_sizeButton.setVisible(true);
	adMusic_syncButton.setVisible(true);
	if($AdMusicGui::isSyncing != 1)
	{
		if($AdMusicGui::SyncFavorites == 1)
			adMusic_syncButton.setText("Resync");
		else
			adMusic_syncButton.setText("Sync");
	}
}

function adMusicButtonSettings()
{
	adMusic_scroll.setvisible(false);
	adMusic_list.setvisible(false);
	adMusic_favList.setvisible(false);
	adMusic_settingsPane.setvisible(true);
	adMusic_MusicButton.setColor("0.784 0.784 1 1");
	adMusic_FavoritesButton.setColor("0.784 0.784 1 1");
	adMusic_SettingsButton.setColor("0.784 1 1 1");
	$AdMusicGui::ActivePane = "Settings";
	adMusic_playButton.setVisible(false);
	adMusic_stopButton.setVisible(false);
	adMusic_favsButton.setvisible(false);
	adMusic_nameButton.setVisible(false);
	adMusic_durButton.setVisible(false);
	adMusic_sizeButton.setVisible(false);
	adMusic_syncButton.setVisible(false);
}

function adMusicButtonPlay()
{
	switch$($AdMusicGui::ActivePane)
	{
		case "Music":
			%id = adMusic_list.getSelectedID();
			%file = getField(adMusic_list.getRowTextByID(%id),0);
			playAdMusic(%file);
		case "Favorites":
			%id = adMusic_favList.getSelectedID();
			%file = getField(adMusic_favList.getRowTextByID(%id),0);
			playAdMusic(%file);
		default:
			return;
	}
}

function adMusicButtonStop()
{
	stopAdMusic();
}

function adMusicButtonFavs()
{
	if($AdMusicGui::ActivePane $= "Music")
	{
		%data = adMusic_list.getRowTextByID(adMusic_list.getSelectedID());
		if(%data $= "")
			return;
		%name = getField(%data,0);
		for(%x=1;%x<$Pref::Music::FavsCount+1;%x++)
			if($Pref::Music::Favs[%x] $= %name)
				return;
		$Pref::Music::Favs[$Pref::Music::FavsCount++] = %name;
		adMusic_favList.addRow($Pref::Music::FavsCount,%data);
	}
	else if($AdMusicGui::ActivePane $= "Favorites")
	{
		%name = $Pref::Music::Favs[adMusic_favList.getSelectedID()];
		if(%name $= "")
			return;
		for(%y=adMusic_favList.getSelectedID()+1;%y<$Pref::Music::FavsCount+1;%y++)
		{
			adMusic_favList.setRowByID(%y-1,adMusic_favList.getRowTextByID(%y));
			$Pref::Music::Favs[%y-1] = $Pref::Music::Favs[%y];
		}
		adMusic_favList.removeRowByID($Pref::Music::FavsCount);
		$Pref::Music::Favs[$Pref::Music::FavsCount] = "";
		$Pref::Music::FavsCount--;
		return;
	}
}

function adMusicVolumeSlider(%volume)
{
	%volume = mFloatLength(%volume,2);
	adMusic_volumeSlider.setValue(%volume);
	alxSetChannelVolume(8, %volume);
	//AdMusic2D.volume = %volume;
}

function adMusicButtonSync()
{
	if($AdMusicGui::isSyncing)
	{
		cancel($AdMusicGui::Sync);
		adMusicFinishedSync($adMusicGui::PaneSync);
	}
	else if($AdMusicGui::ActivePane $= "Music")
	{
		$adMusicGui::PaneSync = "Music";
		initAdMusicCheck();
	}
	else if($AdMusicGui::ActivePane $= "Favorites")
	{
		$adMusicGui::PaneSync = "Favorites";
		adMusicSyncFavs(1);
	}	
}

//Stolen from Randy
function AddBind(%division, %name, %command)
{
	for(%i=0;%i<$remapCount;%i++)
	{
		if($remapDivision[%i] $= %division)
		{
			%foundDiv = 1;
			continue;
		}
		if(%foundDiv && $remapDivision[%i] !$= "")
		{
			%position = %i;
			break;
		}
	}
	if(!%foundDiv)
	{
		error("Division not found: " @ %division);
		return;
	}
	if(!%position)
	{
		$remapName[$remapCount] = %name;
		$remapCmd[$remapCount] = %command;
		$remapCount++;
		return;
	}
	for(%i=$remapCount;%i>%position;%i--)
	{
		$remapDivision[%i] = $remapDivision[%i - 1];
		$remapName[%i] = $remapName[%i - 1];
		$remapCmd[%i] = $remapCmd[%i - 1];
	}
	$remapDivision[%position] = "";
	$remapName[%position] = %name;
	$remapCmd[%position] = %command;
	$remapCount++;
}

if(!$addedAdvMusic)
{
	AddBind("Gui","Toggle Advanced Music GUI","openAdMusicGUI");
	$addedAdvMusic = 1;
	$AdMusicGui::ActivePane = "Music";
	for(%x=1;%x<$Pref::Music::Favscount+1;%x++)
		adMusic_favList.addRow(%x,$Pref::Music::Favs[%x] TAB "N/A" TAB "N/A");
}